# Full Map Indexing Strategy

## Introduction

This strategy is to get all the signature for classes and methods in the codebase.

## Sample output

```text
locify/tree_sitter/parser.py:
...⋮...
 18│class TagKind(Enum):
...⋮...
 23│class TreeSitterParser:
 24│
 25│    def __init__(self) -> None:
...⋮...
 28│    def get_tags_from_file(self, abs_path: str, rel_path: str) -> list[ParsedTag]:
...⋮...
locify/utils/file.py:
...⋮...
  8│class GitRepoUtils:
  9│
 10│    def __init__(self, abs_repo_path: str) -> None:
 11│        if not Path(abs_repo_path).is_absolute():
 12│            raise ValueError("The path must be absolute")
 13│
 14│        self.repo_path = Path(abs_repo_path)
 15│        try:
 16│            self.repo = Repo(self.repo_path)
 17│        except:
...⋮...
 20│    def get_all_absolute_tracked_files(self) -> list[str]:
...⋮...
 23│    def get_all_absolute_staged_files(self) -> list[str]:
...⋮...
 26│    def get_absolute_tracked_files_in_directory(self, rel_dir_path: str) -> list[str]:
...⋮...
 31│def read_text(abs_path: str) -> str:
...⋮...
locify/utils/llm.py:
...⋮...
  4│def get_token_count_from_text(model_name: str, text: str) -> int:
...⋮...
locify/utils/path.py:
...⋮...
  4│class PathUtils:
  5│
  6│    def __init__(self, root: str) -> None:
...⋮...
  9│    def get_absolute_path_str(self, rel_path: str) -> str:
...⋮...
 12│    def get_relative_path_str(self, abs_path: str) -> str:
...⋮...
 15│def has_image_extension(path: str) -> bool:
...⋮...
tests/test_file_utils.py:
...⋮...
  9│@pytest.fixture
 10│def temp_git_repo(tmp_path):
...⋮...
 41│@pytest.fixture
 42│def git_utils(temp_git_repo):
...⋮...
 46│def test_init_valid_repo(temp_git_repo):
...⋮...
 52│def test_init_invalid_repo(tmp_path):
...⋮...
 59│def test_get_all_abs_tracked_files(git_utils):
...⋮...
 77│def test_get_all_abs_staged_files(git_utils):
...⋮...
 86│def test_get_abs_tracked_files_in_directory(git_utils):
...⋮...
 99│def test_get_abs_tracked_files_in_directory_with_trailing_slash(git_utils):
...⋮...
107│def test_get_abs_tracked_files_in_subdirectory(git_utils):
...⋮...
116│def test_empty_directory(git_utils, temp_git_repo):
...⋮...
126│def test_read_text_with_regular_file(tmp_path):
...⋮...
135│def test_read_text_with_image_file(tmp_path):
...⋮...
tests/test_llm_utils.py:
...⋮...
  4│def test_get_token_count_from_text():
...⋮...
tests/test_path_utils.py:
...⋮...
  8│@pytest.fixture
  9│def path_utils():
...⋮...
 12│def test_get_absolute_path_str(path_utils):
...⋮...
 20│def test_get_relative_path_str(path_utils):
...⋮...
 28│def test_get_absolute_path_str_with_non_existing_path(path_utils):
...⋮...
 36│def test_get_relative_path_str_with_non_project_path(path_utils):
...⋮...
 40│def test_has_image_extension_png():
...⋮...
```
